# Interface StiltsReporter

All Known Implementing Classes:
  `ConeMultiWindow, DalMultiWindow, MatchWindow, SiaMultiWindow, SkyDalReporter, SsaMultiWindow, TopcatTapTableLoadDialog, UploadMatchPanel`

public interface StiltsReporter
Defines a component that can generate a STILTS command, assumed equivalent in some way to its current state.

Since:
  19 Sep 2024
Author:
  Mark Taylor

## Method Summary

Modifier and Type
Method
Description
`void`
`addStiltsListener(ActionListener listener)`
Adds a listener that will be messaged if the current stilts command might have changed.
`uk.ac.starlink.ttools.task.StiltsCommand`
`createStiltsCommand(TopcatTableNamer tableNamer)`
Returns a stilts command corresponding to current state.
`default <T> uk.ac.starlink.ttools.task.Setting`
`pset(uk.ac.starlink.task.Parameter<T> param, T tval)`
Creates a setting for a given parameter and value.
`void`
`removeStiltsListener(ActionListener listener)`
Removes a listener that may have been previously added.

## Method Details

### createStiltsCommand

uk.ac.starlink.ttools.task.StiltsCommand createStiltsCommand(TopcatTableNamer tableNamer)
Returns a stilts command corresponding to current state.

Parameters:
  `tableNamer` - table namer
Returns:
  command, or null if current state does not correspond to one

### addStiltsListener

void addStiltsListener(ActionListener listener)
Adds a listener that will be messaged if the current stilts command might have changed.

Parameters:
  `listener` - listener to add

### removeStiltsListener

void removeStiltsListener(ActionListener listener)
Removes a listener that may have been previously added.

Parameters:
  `listener` - listener to remove

### pset

default <T> uk.ac.starlink.ttools.task.Setting pset(uk.ac.starlink.task.Parameter<T> param, T tval)
Creates a setting for a given parameter and value. This is simply a shorthand for `StiltsCommand.createParamSetting(Parameter, T)`, of which repeated invocations are required by StiltsReporter implementations, and which is otherwise verbose.

Parameters:
  `param` - task parameter
  `tval` - typed value for parameter
Returns:
  setting object